#ifdef WIN32
#ifndef WINDOWSSTORE_H
#define WINDOWSSTORE_H

#ifdef __cplusplus
extern "C" {
#endif

#include <windows.h>
#include <wincrypt.h>

#include <stdbool.h>

/** @brief Access the Windows certificate store
 *
 * @param [in] to_install strv of DER encoded certificates to be added.
 * @param [in] to_remove strv of DER encoded certificates to be remvoed.
 * @param [in] user_store set to True if the certificates should be installed
 *             only for the current user. O for system wide installation.
 * @returns 0 on success an errorcode otherwise.
 */
int write_stores_win (char **to_install, char **to_remove,
                      bool user_store);

/* The do_ functions are private helper functions and should not be used
 * from other code. They are not static to allow it to use them directly
 * in unit tests */
void do_remove(HCERTSTORE hStore, char **to_remove);
void do_install(HCERTSTORE hStore, char **to_install);

#ifdef __cplusplus
}
#endif

#endif // WINDOWSSTORE_H
#endif // WIN32
